Window_BattleLog.prototype.messageSpeed = function() {
  switch (ConfigManager.battleLogSpeed) {
    case 0:
	  return 0;
	  break;
	case 1:
	  return 5;
	  break;
	default:
	  return 16;
	}
};

Window_Message.prototype.processNewLine = function(textState) {
if (ConfigManager.battleLogSpeed != 0) { this._lineShowFast = false } else { this._lineShowFast = true }
    Window_Base.prototype.processNewLine.call(this, textState);
    if (this.needsNewPage(textState) && ConfigManager.battleLogSpeed != 0) {
        this.startPause();
    }
};

Window_BattleLog.prototype.addText = function(text) {
  // // If Scroll Text Sprite Exists Add it
   if (this._scrollTextSprite) {
     this._scrollTextSprite.addLine(text);
     if (ConfigManager.battleLogSpeed === 3) {
       this.push('wait');
     } else if (ConfigManager.battleLogSpeed === 4) {
       let currentSkill = !!BattleManager._action && BattleManager._action._item ? BattleManager._action._item.object() : null;
       let skillId = !!DataManager.isSkill(currentSkill) ? currentSkill.id : 0;
       let ACS_SKILLS = [
         46,47,48,49,50,51,52,53,54,55,56,57,59,60,61, // OMORI ACS, RELEASE ENERGY AND RELEASE STRESS
         86,87,88,89,90,91,92,93,94,97,98,99,100,101, // AUBREY ACS
         126,127,128,129,130,131,132,133,134,137,138,139, // KEL ACS
         168,167,170,171,172,173,174,175,176,178,179,180 // HERO ACS
        ];
       if(ACS_SKILLS.contains(skillId)) {
        this.push("wait"); 
       }
       else if(BattleManager._phase === "endBattle" || BattleManager._phase === "victory") {
         this.push("wait");
       } 
       else {
        this.push('wait');
        this.push('wait');
       }
     }
   };
  // Run Original Function
  _TDS_.OmoriBattleSystem.Window_BattleLog_addText.call(this, text);
};

Window_BattleLog.prototype.displayCustomActionText = function(subject, target, item) {
  // Make Custom Action Text
  var text = this.makeCustomActionText(subject, target, item);
  // If Text Length is more than 0
  if (text.length > 0) {
    if(!!this._multiHitFlag && !!item.isRepeatingSkill) {return;}
    // Get Get
    text = text.split(/\r\n/);
    for (var i = 0; i < text.length; i++) { this.push('addText', text[i]); }
    // Add Wait
    if (ConfigManager.battleLogSpeed != 0) { this.push('wait', 15); }

  }
  if(!!item.isRepeatingSkill) {this._multiHitFlag = true;}
};